export interface ScoolcodeProfile {
    id: string;
    username: string;
    crmUserId: string;
    email: string;
    name: {
        first: string;
        last: string;
    };
    fullName: string;
    kind: {
        teacher: boolean;
        student: boolean;
        leadTeacher: boolean;
        contributor: boolean;
        schoolCoordinator: boolean;
        parent: boolean;
        administrator: boolean;
        developer: boolean;
        mixer: boolean;
        beta: boolean;
        xmas: boolean;
    };
    displayName: string;
    school: string;
    group: string;
    storage: {
        size: number;
        quota: number;
    };
    parent: string;
    assetGallery: string;
    blockGallery: string;
    enabled: boolean;
    deleted: boolean;
}
export declare class ScoolcodeStrategy {
    constructor({ clientID, clientSecret, callbackURL, requestCRMToken, passReqToCallback }: {
        clientID: string;
        clientSecret: string;
        callbackURL: string;
        requestCRMToken?: boolean;
        passReqToCallback?: boolean;
    }, handler: (token: {
        scoolcode: string;
        crm?: string;
    }, profile: ScoolcodeProfile, callback: (err: Error | null, profile?: any) => void, req?: any) => void);
}
export declare const Strategy: typeof ScoolcodeStrategy;
