"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Strategy = exports.ScoolcodeStrategy = void 0;
var request = require("request");
var OAuth2Strategy = require("passport-oauth2").Strategy;
OAuth2Strategy.prototype.userProfile = function (accessToken, done) {
    request('https://api.scoolcode.com/accounts/me?access_token=' + accessToken, function (error, response, body) {
        if (error || (response && response.statusCode !== 200))
            done(new Error("Forbidden"));
        else {
            var o = JSON.parse(body);
            o.accessToken = accessToken;
            done(null, o);
        }
    });
};
function getCRMToken(accessToken) {
    return new Promise(function (resolve, reject) {
        request('https://api.scoolcode.com/accounts/me/crm-token?access_token=' + accessToken, function (error, response, body) {
            if (error || (response && response.statusCode !== 200)) {
                reject(new Error("Forbidden: failed to get CRM token"));
            }
            else {
                var o = JSON.parse(body);
                resolve(o.crmToken);
            }
        });
    });
}
var ScoolcodeStrategy = /** @class */ (function () {
    function ScoolcodeStrategy(_a, handler) {
        var _this = this;
        var clientID = _a.clientID, clientSecret = _a.clientSecret, callbackURL = _a.callbackURL, requestCRMToken = _a.requestCRMToken, passReqToCallback = _a.passReqToCallback;
        var internalHandler;
        if (passReqToCallback) {
            internalHandler = function (req, accessToken, refreshToken, profile, cb) { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, _c, e_1;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 6, , 7]);
                            if (!(profile && profile.username)) return [3 /*break*/, 4];
                            _a = handler;
                            _b = {
                                scoolcode: accessToken
                            };
                            if (!requestCRMToken) return [3 /*break*/, 2];
                            return [4 /*yield*/, getCRMToken(accessToken)];
                        case 1:
                            _c = _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            _c = undefined;
                            _d.label = 3;
                        case 3:
                            _a.apply(void 0, [(_b.crm = _c,
                                    _b), profile,
                                cb,
                                req]);
                            return [3 /*break*/, 5];
                        case 4:
                            cb(new Error("Forbidden: failed to fetch profile."));
                            _d.label = 5;
                        case 5: return [3 /*break*/, 7];
                        case 6:
                            e_1 = _d.sent();
                            cb(e_1);
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/];
                    }
                });
            }); };
        }
        else {
            internalHandler = function (accessToken, refreshToken, profile, cb) { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, _c, e_2;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 6, , 7]);
                            if (!(profile && profile.username)) return [3 /*break*/, 4];
                            _a = handler;
                            _b = {
                                scoolcode: accessToken
                            };
                            if (!requestCRMToken) return [3 /*break*/, 2];
                            return [4 /*yield*/, getCRMToken(accessToken)];
                        case 1:
                            _c = _d.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            _c = undefined;
                            _d.label = 3;
                        case 3:
                            _a.apply(void 0, [(_b.crm = _c,
                                    _b), profile,
                                cb]);
                            return [3 /*break*/, 5];
                        case 4:
                            cb(new Error("Forbidden: failed to fetch profile."));
                            _d.label = 5;
                        case 5: return [3 /*break*/, 7];
                        case 6:
                            e_2 = _d.sent();
                            cb(e_2);
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/];
                    }
                });
            }); };
        }
        var strategy = new OAuth2Strategy({
            authorizationURL: 'https://api.scoolcode.com/oauth/authorize',
            tokenURL: 'https://api.scoolcode.com/oauth/token',
            clientID: clientID,
            clientSecret: clientSecret,
            callbackURL: callbackURL,
            passReqToCallback: passReqToCallback
        }, internalHandler);
        strategy.name = "scoolcode";
        return strategy;
    }
    return ScoolcodeStrategy;
}());
exports.ScoolcodeStrategy = ScoolcodeStrategy;
exports.Strategy = ScoolcodeStrategy;
//# sourceMappingURL=index.js.map